% distsavings.m

fye = zeros(na,N,T);     fyu = zeros(na,1);     fr = zeros(na,1);
foe = zeros(na,N,T);     fou = zeros(na,1);

fye(1,1,1) = chi/(chi + gamma);                            % Initial guess
foe(1,1,1) = gamma/(chi + gamma);
newb       = (1/(inv(gamma) + inv(chi)));

aidxye  = zeros(na,N,T);     aidxoe  = zeros(na,N,T);
prob1ye = zeros(na,N,T);     prob1oe = zeros(na,N,T);    prob2ye = zeros(na,N,T);     prob2oe = zeros(na,N,T);

for itau = 1 : T
  [ aidxyetmp  , prob1ye(:,:,itau)  , prob2ye(:,:,itau)  ] = stataux(adecye(:,:,itau),agrid);
  [ aidxoetmp  , prob1oe(:,:,itau)  , prob2oe(:,:,itau)  ] = stataux(adecoe(:,:,itau),agrid);
  aidxyetmp(aidxyetmp == 1) = 2;     aidxye(:,:,itau)  = aidxyetmp;
  aidxoetmp(aidxoetmp == 1) = 2;     aidxoe(:,:,itau)  = aidxoetmp;
end

[ aidxyu , prob1yu , prob2yu ] = stataux(adecyu,agrid);           aidxyu(aidxyu == 1) = 2;
[ aidxou , prob1ou , prob2ou ] = stataux(adecou,agrid);           aidxou(aidxou == 1) = 2;
[ aidxr  , prob1r  , prob2r  ] = stataux(adecr,agrid);            aidxr(aidxr == 1)   = 2;

aidxbeq  = zeros(na,1);
for ia = 1 : na
  aidxbeq(ia)  = find(min(agrid(ia) + beqy,agrid(end)) <= agrid,1,'first');   % find first grid point that exceeds the decision rule a'
end
prob1beq = (agrid(aidxbeq)-min(agrid+beqy,agrid(end)))./(agrid(aidxbeq) - agrid(aidxbeq-1));
prob2beq = (min(agrid+beqy,agrid(end))-agrid(aidxbeq-1))./(agrid(aidxbeq) - agrid(aidxbeq-1));

fye1 = zeros(na,N,T);   foe1 = zeros(na,N,T);   fou1 = zeros(na,1);

crit = 1;       maxit = na/3;      it = 0;                % initialization

P_a = (1-gamma) * (1-delta) * P;
P_b = (1-delta) * P;

while (crit > 1e-3) && (it < maxit)
  
  fyeold = fye;   fyuold = fyu;   foeold = foe;   fouold = fou;   frold = fr;
  
  for i = 1 : 100
    
    fye1(:,z0idx,1) = (1-gamma)*q*theta*fyu;
    fyu1 = (1-gamma)*(1-q*theta)*fyu;
    fyu1(1,1) = fyu1(1,1) + newb;
    fou1 = (1-chi)*fou + gamma*fyu;
    
    for itau = 2 : T-1
      fye1(:,:,itau) = fye(:,:,itau-1) * P_a;
      tmp = repmat(split(itau,:),na,1);
      sepy = sum(fye1(:,:,itau).*(tmp == 1),2);
      fye1(:,:,itau) = (tmp < 1).*fye1(:,:,itau);
      foe1(:,:,itau) = ( (1-chi) * foe(:,:,itau-1) + gamma * fye(:,:,itau-1) )* P_b;
      tmp = repmat(splito(itau,:),na,1);
      sepo = sum(foe1(:,:,itau).*(tmp == 1),2);
      foe1(:,:,itau) = (tmp < 1).*foe1(:,:,itau);
      for ia = 1 : na
        fyu1(idxSP(ia,itau),1) = fyu1(idxSP(ia,itau),1) + squeeze((1-gamma)*delta*sum(fye(ia,:,itau-1),2)) + sepy(ia);
        fou1(idxSP(ia,itau),1) = fou1(idxSP(ia,itau),1) + squeeze((1-chi)*delta*sum(foe(ia,:,itau-1),2))   + sepo(ia) + ...
                                 squeeze(gamma*delta*sum(fye(ia,:,itau-1),2));
      end
    end
    
    fye1(:,:,T) = (fye(:,:,T-1) + fye(:,:,T)) * P_a;
    tmp = repmat(split(T,:),na,1);
    sepy = sum(fye1(:,:,T).*(tmp == 1),2);
    fye1(:,:,T) = (tmp < 1).*fye1(:,:,T);
    foe1(:,:,T) = (1-chi) * (1-delta) * (foe(:,:,T-1) + foe(:,:,T)) * P + gamma * (1-delta) * (fye(:,:,T-1) + fye(:,:,T)) * P;
    tmp = repmat(splito(T,:),na,1);
    sepo = sum(foe1(:,:,T).*(tmp == 1),2);
    foe1(:,:,T) = (tmp < 1).*foe1(:,:,T);  
    for ia = 1 : na
      fyu1(idxSP(ia,T),1) = fyu1(idxSP(ia,T),1) + squeeze((1-gamma)*delta*(sum(fye(ia,:,T-1),2) + sum(fye(ia,:,T),2))) + sepy(ia);
      fou1(idxSP(ia,T),1) = fou1(idxSP(ia,T),1) + squeeze((1-chi)*delta*(sum(foe(ia,:,T-1),2)   + sum(foe(ia,:,T),2))) + sepo(ia) + ...
                            squeeze(gamma*delta*(sum(fye(ia,:,T-1),2) + sum(fye(ia,:,T),2)));
    end
    
    fr1 = gamma*(sum(sum(foe,2),3) + sum(fou,2)) + (1-iota)*fr;
    
    fye = fye1;   foe = foe1;   fyu = fyu1;   fou = fou1;   fr = fr1;
    
    fye1 = zeros(na,N,T);   fyu1 = zeros(na,1);            % Bequests: Distributed among young workers (lump-sum)
    for ia = 1 : na
      fye1(aidxbeq(ia)-1,:,:) = fye1(aidxbeq(ia)-1,:,:) + prob1beq(ia)*fye(ia,:,:);
      fye1(aidxbeq(ia),:,:)   = fye1(aidxbeq(ia),:,:)   + prob2beq(ia)*fye(ia,:,:);
      fyu1(aidxbeq(ia)-1,1)   = fyu1(aidxbeq(ia)-1,1)   + prob1beq(ia)*fyu(ia,:,:);
      fyu1(aidxbeq(ia),1)     = fyu1(aidxbeq(ia),1)     + prob2beq(ia)*fyu(ia,:,:);
    end    
    fye = fye1;   fyu = fyu1;
    
    fye1 = zeros(na,N,T);   fyu1 = zeros(na,1);   foe1 = zeros(na,N,T);
    fou1 = zeros(na,1);     fr1  = zeros(na,1);
    
    for itau = 1 : T
      for ia = 1 : na
        for iz = 1 : N
          fye1(aidxye(ia,iz,itau)-1,iz,itau) = fye1(aidxye(ia,iz,itau)-1,iz,itau) + prob1ye(ia,iz,itau)*fye(ia,iz,itau);
          fye1(aidxye(ia,iz,itau),iz,itau)   = fye1(aidxye(ia,iz,itau),iz,itau)   + prob2ye(ia,iz,itau)*fye(ia,iz,itau);
          foe1(aidxoe(ia,iz,itau)-1,iz,itau) = foe1(aidxoe(ia,iz,itau)-1,iz,itau) + prob1oe(ia,iz,itau)*foe(ia,iz,itau);
          foe1(aidxoe(ia,iz,itau),iz,itau)   = foe1(aidxoe(ia,iz,itau),iz,itau)   + prob2oe(ia,iz,itau)*foe(ia,iz,itau);
        end
        if itau == 1
          fyu1(aidxyu(ia,1)-1,1) = fyu1(aidxyu(ia,1)-1,1) + prob1yu(ia,1)*fyu(ia,1);
          fyu1(aidxyu(ia,1),1)   = fyu1(aidxyu(ia,1),1)   + prob2yu(ia,1)*fyu(ia,1);
          fou1(aidxou(ia,1)-1,1) = fou1(aidxou(ia,1)-1,1) + prob1ou(ia,1)*fou(ia,1);
          fou1(aidxou(ia,1),1)   = fou1(aidxou(ia,1),1)   + prob2ou(ia,1)*fou(ia,1);
          fr1(aidxr(ia,1)-1,1)   = fr1(aidxr(ia,1)-1,1)   + prob1r(ia,1)*fr(ia,1);
          fr1(aidxr(ia,1),1)     = fr1(aidxr(ia,1),1)     + prob2r(ia,1)*fr(ia,1);
        end
      end
    end

   fye = fye1;   foe = foe1;   fyu = fyu1;   fou = fou1;
   
  end
  
  crit = max(max(max(abs(fye-fyeold)./(1+fye)))) + max(max(max(abs(foe-foeold)./(1+foe)))) + max(max(abs(fyu-fyuold)./(1+fyu))) + ...
           + max(max(abs(fou-fouold)./(1+fou)))  + max(abs(fr-frold)./(1+fr));
  it = it + 1;

  % if SHOWMESSAGES == 1,
    fprintf('%2.0f',it);
  % end

end

if abs(sum(sum(sum(fye))) + sum(sum(sum(foe))) + sum(sum(fyu)) + sum(sum(fou)) - 1) > 1e-7
  disp('   Warning: Population measure does not add up to 1!!!')
end
if it == maxit
  disp('   Warning: Maximum number of iterations hit!!!')
end

% fprintf('\n\n   Young E = %7.4f',100*sum(sum(sum(fye))))
% fprintf('\n   Young U = %7.4f',100*sum(sum(fyu)))
% fprintf('\n   Older E = %7.4f',100*sum(sum(sum(foe))))
% fprintf('\n   Older U = %7.4f',100*sum(sum(fou)))

fa  = sum(sum(fye,3),2) + sum(sum(foe,3),2) + sum(fyu,2) + sum(fou,2);
fay = sum(sum(fye,3),2) + sum(fyu,2);
fao = sum(sum(foe,3),2) + sum(fou,2);

meanassets  = fa' *agrid;
meanassetsy = fay'*agrid/sum(fay);
meanassetso = fao'*agrid/sum(fao);

incye = zeros(na,N,T); incoe = zeros(na,N,T); incyu = zeros(na,1); incou = zeros(na,1);
for ia = 1 : na
  for itau = 1 : T
    for iz = 1 : N
      incye(ia,iz,itau) = r*agrid(ia) + w(itau,iz)  + beqy;
      incoe(ia,iz,itau) = r*agrid(ia) + wo(itau,iz);
    end
  end
  incyu(ia,1) = r*agrid(ia) + b  + beqy;
  incou(ia,1) = r*agrid(ia) + bo;
end

popincome = [ popsamp(incye(:),fye(:),1e-5) ; popsamp(incoe(:),foe(:),1e-5) ; ...
              popsamp(incyu(:),fyu(:),1e-5) ; popsamp(incou(:),fou(:),1e-5) ];
meanincome = 4*mean(popincome);

if (uniEPL == 0) && (abs(meanassets/meanincome - 2.3) > 0.1)
  fprintf('adjust beta')
elseif (uniEPL == 0) && (abs(r*meanassets - ra) > 1e-3)
  fprintf('adjust ra')
end

clear incye incoe incyu incou popincome

totalbeq    = iota*agrid'*fr;
beqperyoung = totalbeq / ((chi/(chi + gamma)));

% if abs(beqy-beqperyoung) > 0.003
%   fprintf('beq = %6.4f',beqy)
% end

clear AIDXoe AIDXouA AIDXouB AIDXr AIDXyu AIDXye aidxyetmp aidxoetmp aidxoe aidxouA aidxouB aidxr aidxye aidxyu ...
      foe1 fou1 fouB1 fouBold fr1 foeold fouold frold fye1 fyeold fyu1 fyuold prob1oe prob1ouA prob1ouB ...
      prob1r prob1ye prob1yu prob2oe prob2ouA prob2ouB prob2r prob2ye prob2yu crit conv critgov ia ia1 iz it itau ...
      tmpoe tmpye tmp tmpouA tmpouB tmpyu sepy sepo maxit i