% labormarket.m

nz     = 101;                stdz  = 0.044;                % Productivity process: Grid size and standard deviation
z0idx  = 29;                 kappa = 9.5000;               % Initial productivity index / Payroll tax in percent
b      = 0.2203;             k     = 0.2204;               % Unemployment income younger workers / Vacancy cost
bo     = 0.1617;             wavg0 = 0.3754;               % Unemployment income older workers / Guess for avg wage
QUITS  = 1;                                                % Quits entitle to EPL

init_labormarket;                                          % Initialization

rdisc = 1/betta - 1;                                       % Could substitute beta for r everywhere, but this is easier

vfi_labormarket;                                           % Value function iteration
simul_labormarket;                                         % Compute stationary distribution
critgov = 1;                                               % Initialize

while abs(critgov) > 1e-5                                  % Balance the government budget
  initx_labormarket;   vfi_labormarket;   simul_labormarket;
  critgov = (Rev-Ben)/Rev;                                 % Excess revenues
  kappa   = kappa - 0.10 * critgov;                        % Adjust payroll tax rate
  wavg0   = 0.5*wavg + 0.5*wavg0;                          % Adjust guess for average wage
end

% showstats_labormarket;