% Approximate model with savings.

clearvars
tic

betta = 0.9907;                                            % Subjective discount factor
r     = (1+0.04)^(1/4) - 1;                                % Fixed real interest rate (4 percent annually)
ra    = 0.032;                                             % Interest income
mina  = 1e-4;                                              % Lower bound on assets
maxa  = 50;                                                % Upper bound on assets
na    = 50;                                                % Number of grid points for assets
agrid = linspace(mina^(1/2),maxa^(1/2),na)'.^2;            % Set up grid for assets

uniEPL = 0;

if uniEPL == 1
  tau_u =  5;                                              % Entry phase (in months)
  rho_u = 20;                                              % Slope (in dwys)
end

labormarket;                                               % Labor market part: Obtain income dynamics

iota  = 1/60;                                              % Controls length of retirement period (1/iota quarters)
br    = 0.28;                                              % Retirement benefit
beqy  = 0.00001;                                           % Per-capita bequests (disabled)

periodreturnssavings;                                      % Period returns
vfirsavings;                                               % Solve Bellman equation for retired workers
vfiosavings;                                               % Solve Bellman equation for older   workers
vfiysavings;                                               % Solve Bellman equation for young   workers
distsavings;                                               % Compute stationary distribution
evalresults;                                               % Assess results
toc