% periodreturnssavings.m

RRye = -100000000000*ones(na,na*N,T);            RRyetmp = -100000000000*ones(na,na*N);
RRyu = -100000000000*ones(na,na);
RRoe = -100000000000*ones(na,na*N,T);            RRoetmp = -100000000000*ones(na,na*N);
RRou = -100000000000*ones(na,na);
RRr  = -100000000000*ones(na,na);

for itau = 1 : T  
 for ia = 1 : na  
  for iz = 1 : N                                                               % Employed workers
    c = (1+r)*agrid(ia) + w(itau,iz)  + beqy + (-1000000)*split(itau,iz)  - agrid;
    c = max(c,1e-12);    
    RRyetmp(:,(iz-1)*na+ia) = 1 - 1./c;
    c = (1+r)*agrid(ia) + wo(itau,iz) + (-1000000)*splito(itau,iz) - agrid;
    c = max(c,1e-12);
    RRoetmp(:,(iz-1)*na+ia) = 1 - 1./c;
  end  
  if itau == 1
   c = (1+r)*agrid(ia) + b  + beqy - agrid;     c = max(c,1e-12);          % Unemployed workers
   RRyu(:,ia) = 1 - 1./c;
   c = (1+r)*agrid(ia) + bo - agrid;            c = max(c,1e-12);
   RRou(:,ia) = 1 - 1./c;
   c = (1+r)*agrid(ia) + br - agrid;            c = max(c,1e-12);
   RRr(:,ia) = 1 - 1./c;
  end
 end
 RRye(:,:,itau)  = RRyetmp;
 RRoe(:,:,itau)  = RRoetmp;
end

% In the following part, I construct a matrix idxSP that describes the transition on the asset grid when a household
% receives a severance payment. In particular, idxSP(i,j) is the index on the asset grid when a household with previous
% assets agrid(i) receives a severance payment phi(j). In other words, the row characterizes assets before receipt, and
%the column characterizes assets after receipt.

idxSP = zeros(na,T);
for j = 1 : T                                               % Find closest grid point for any combination
   idxSP(:,j) = interp1(agrid,1:1:na,min(max(max(phi(j),0) + agrid,mina),maxa-0.0000001),'nearest');
end