% stataux.m

function [ kidx , prob1 , prob2 ] = stataux(kdecis,kgrid)

[ nk , N ] = size(kdecis);                % this simply reads out the size of the capital grid

kidx  = zeros(nk,N);
prob1 = zeros(nk,N);
prob2 = zeros(nk,N);

for i1 = 1 : N,
  for i2 = 1 : nk,
    kidx(i2,i1)  = find(kdecis(i2,i1)<=kgrid,1,'first');   % find first grid point that exceeds the decision rule a'
  end
end

prob1(kidx > 1)  = (kgrid(kidx(kidx  > 1))-kdecis(kidx > 1))./(kgrid(kidx(kidx > 1)) - kgrid(kidx(kidx > 1)-1));
prob2(kidx > 1)  = (kdecis(kidx > 1)-kgrid(kidx(kidx > 1)-1))./(kgrid(kidx(kidx > 1)) - kgrid(kidx(kidx > 1)-1));
prob1(kidx <= 1) = 1;               % this is the case where a'() = 0 (borrowing limit)
prob2(kidx <= 1) = 0;