% initx.m
%
% This is a shortened version of init.m, the main initialization script. Only the EPL scheme, annuities and the values
% of early retired workers are recomputed. Moreover, I use smaller values for the number of value function iterations
% because the initial guesses are presumably closer to the true solution.

io1 = 8;   iy1 = 2;   iy2 = 4;   xx = 0.65;               % Number of iterations / Damping parameter

if uniEPL == 2
  phi = max( 0 , (rho_u/365)*wavg0 * ([ 0 : 1 : T-1 ]' - tau_u/3) );
end

philag = phi;   philag(1:end-1) = phi(2:end);   philag(end) = philag(end-1);

btildeoA = bo + upsil*annfaco*phi;                         % Non-employment income for older workers
UoA      = -(1./btildeoA-1)/(1-(1/(1+r))*(1-chi));         % Non-employed older workers: Laid off when old
wF = w;  woF = wo;  wW = w;  woW = wo;

if exist('wx0','var')                                      % Reinitialize in model with rigid wages
  critwx = 100;   itwx = 1;
end

if exist('Hprem','var')                                    % Reinitialize in model with human capital accumulation
  woWH = woH;   woFH = woH;   woW = wo;   woF = wo;   wWH = wH;   wFH = wH;   wW = w;   wF = w;
end