!---------------------------------------------------------------------------------------------------------------------------------------------------
!	module globals: define global variables
!---------------------------------------------------------------------------------------------------------------------------------------------------

module globals
	
	implicit none
	
	save
		
	!	convergence check
	
	double precision :: TOL_kappa = 1.0d-4, TOL_nash = 1.0d-5, TINY = 1.0d-20
	integer :: MAX_kappa = 100, WLF_num
	
	!	model specification
	
	double precision :: delta_sp, young_sp, reform_sp
	
	!	size of state space
	
	integer, parameter :: NP = 200, NT = 120, NW = 101, NZ = 101, NC = 2
	character (len=20) :: fmt = "(101(ES14.7,2X))"
			
	!	model parameters
	
	double precision :: rho, psi, beta, sigma, khi, zeta, delta
	double precision :: gamma, By, Bo, A, k, nu, leis, sig_z, prob_z, P(NZ,NZ), zGrid(NZ)
	integer :: iz0, model_period

	!	auxiliary variables
	
	double precision :: Wn(NP), theta(NP), jfind, kappa(NP), Edur, EdurP, annfacO, annfacY, avg_w, phi(NT,NC), phi0, phi1
	
	!	value functions
	
	double precision :: R, Ul(NT,NC), Uo(NT,NC), Wo(NT,NZ,NC), Wy(NT,NZ,NC), Uy(NT,NC), UyP(NT,NC), Jo(NT,NZ,NC), Jy(NT,NZ,NC)
	double precision :: Wo_w(NT,NZ,NW,NC), Wy_w(NT,NZ,NW,NC), Jo_w(NT,NZ,NW,NC), Jy_w(NT,NZ,NW,NC)
	
	!	wage functions
	
	double precision :: wwo(NP,NT,NZ,NC), wwy(NP,NT,NZ,NC), wmin, wmax
		
	!	separation decisions
	
	integer :: sepy(NP,NT,NW,NC), sepo(NP,NT,NW,NC)
	double precision :: sepy_J(NT,NZ,NW,NC), sepy_W(NT,NZ,NW,NC), sepo_J(NT,NZ,NW,NC), sepo_W(NT,NZ,NW,NC)
	
	
	!	equilibrium distributions
	
	double precision :: LE(NT,NZ,NW,NC,2), LU(NT,NC,3)
		
	!	index variables
	
	integer :: ip, it, iz, ic, iw, iw_p
	
	!	additional stuffs for rigid wage extension
	
	double precision :: ww_r, alpha, wGrid(NW)
	
	!	timer

	character (len=8) :: startdate, finishdate
	character (len=10):: starttime, finishtime

end module	