!---------------------------------------------------------------------------------------------------------------------------------------------------
!	program for the main economy
!---------------------------------------------------------------------------------------------------------------------------------------------------

program main

	use globals
	use misc_functions
	use solve_model
	use results_transition
	use results_welfare
	
	implicit none
		
	!	set the starting time

	call date_and_time(startdate,starttime)
		
	!	initialize parameters
	
	call initial_parameters()
	
	!	set initial values	
	
	call initialize_layoff_payments()
	
	!	initial guess for kappa
	
	call initialize_time_path()

	!	compute model equilibrium
	
	call solve_transition_path()

	!	back to steady-state 0
	
	call compute_model_backwards()
	
	!	transition path
	
	call characterize_transition()
		
	!	welfare figures
	
	call compute_welfare_figures()
		
	!	set the finishing time

	call date_and_time(finishdate,finishtime)

	!	print the starting and finishing times

	write(*, '(/)') 
	write(*, '(12A)') 'The program started at  ', startdate(7:8),'/',startdate(5:6),'/',startdate(1:4),' ', &
												  starttime(1:2),'h',starttime(3:4),'m',starttime(5:6)
	write(*, '(12A)') 'The program finished at ', finishdate(7:8),'/',finishdate(5:6),'/',finishdate(1:4),' ', &
												  finishtime(1:2),'h',finishtime(3:4),'m',finishtime(5:6)
		
	
end program main