% Model with rigid wages.

clearvars
tic

alfa = 0.90;                                               % Weight on old wage

DOWNWARDRIGID = 0;                                         % (not used in the paper) Set this to 1 and alfa to zero 
alfadown      = 0.9950;                                    % (not used in the paper) w1 = max(wNash,alfadown*w0)


%%   Set parameter values.

nz = 101;   stdz = 0.044;   kappa = 9.50;   uniEPL = 0;
if     alfa == 0.25
  b = 0.2296;     bo = 0.1663;     k = 0.2380;     wavg0 = 0.3902;     z0idx = 31;
elseif alfa == 0.50
  b = 0.2384;     bo = 0.1717;     k = 0.2540;     wavg0 = 0.4046;     z0idx = 33;
elseif alfa == 0.75
  b = 0.2462;     bo = 0.1781;     k = 0.2760;     wavg0 = 0.4181;     z0idx = 35;
elseif alfa == 0.90
  b = 0.2672;     bo = 0.1947;     k = 0.3015;     wavg0 = 0.4544;     z0idx = 40;
elseif DOWNWARDRIGID == 1
  b = 0.2770;     bo = 0.2322;     k = 0.3000;     wavg0 = 0.4835;     z0 = 0.47;
end
init;
if DOWNWARDRIGID == 0
  nw = 50;   wgrid = linspace(0.15,0.70,nw);
else
  nw = 50;   wgrid = linspace(0.40,0.72,nw);
  z  = [ linspace(0,0.32,5)' ; linspace(0.33,1,nz-5)' ];
  z0idx = sum(z <= z0);
end

LOAD_DISTINIT = 0;                                         % Decent initial guess speeds up compuations a lot
vfirigid;                                                  % Value function iteration
simulrigid;                                                % Compute stationary distribution

for calibrationit = 1 : 3                                  % Uncomment to calibrate b and bo
  critgov = 1;                                             % Initialize
  while abs(critgov) > 0.008                               % Balance the government budget
    initx;   vfirigid;   simulrigid;                       % Solve the model
    critgov = (Rev-Ben)/Rev;                               % Excess revenues
    kappa   = kappa - 0.10 * critgov;                      % Adjust payroll tax rate
    wavg0   = 0.5*wavg + 0.5*wavg0;                        % Adjust guess for average wage
  end
  b  = b  - 0.28 * (b/wavgy  - 0.58);                      % Calibration: Set new value for b
  bo = bo - 0.28 * (bo/wavgo - 0.4540);   fprintf('x ')    % Calibration: Set new value for bo
end

showstatsrigid;
toc

% save distinitrigid.mat ZZye ZZoe ZZyu ZZou               % To provide decent initial guess next time (see above)