% showstatsrigid.m

DO_PART1 = 1;                          % Compute job destruction rates
DO_PART2 = 1;                          % Display statistics from the model (e.g. for calibration)
DO_PART3 = 1;                          % Display parameters and statistics from the model (e.g. to create a txt-file)


%%   PART 1:   Compute job destruction rates.

if DO_PART1 == 1
  
  qo = sum(sum(sum(ZZoe)))+sum(sum(ZZou));   uo = sum(sum(ZZou))/qo;   % Population share and unemployment rate (o)
  qy = 1-qo;                            uy   = sum(sum(ZZyu))/qy;      % Population share and unemployment rate (y)
  u  = qy*uy+qo*uo;                     outp = sum(sum(ZZye+ZZoe,3),1)*z; % Total unemployment rate // Total output

  zavgy = (sum(sum(ZZye,3),1)*z)/sum(sum(sum(ZZye)));                  % Average productivity (young)
  zavgo = (sum(sum(ZZoe,3),1)*z)/sum(sum(sum(ZZoe)));                  % Average productivity (old)
  zavg  = (sum(sum(sum(ZZye)))*zavgy + sum(sum(sum(ZZoe)))*zavgo)/(1-u); % Average productivity (all)

  ZZye1 = zeros(T,N,nw);        ZZyu1 = zeros(T,1);        ZZoe1 = zeros(T,N,nw);     ZZou1 = zeros(T,2);

  septemp = 0;                                                         % Compute separation rate for temporary jobs   
  for t = 2 : 9
    ZZye1x = squeeze(ZZye1(t,:,:))';
    ZZoe1x = squeeze(ZZoe1(t,:,:))';
    for iz = 1 : N
      for iw = 1 : nw
        if ZZye(t-1,iz,iw) > 0
          ZZye1x(widx(t-1,iz,iw),:)  = ZZye1x(widx(t-1,iz,iw),:)  + (1-gamma)*(1-delta)*ZZye(t-1,iz,iw)*P(iz,:);
          ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
          elseif ZZoe(t-1,iz,iw) > 0
          ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
        end
      end
    end
    ZZye1(t,:,:) = ZZye1x';
    ZZoe1(t,:,:) = ZZoe1x';
    septemp = septemp + sum(sum(sum(ZZye1(t,:,:).*(split(t,:,:)==1)))) + ...
                        sum(sum(sum(ZZoe1(t,:,:).*(splito(t,:,:)==1)))) + chi*sum(sum(sum(ZZoe(t-1,:,:))));
  end
  septemp = delta + septemp/(sum(sum(sum(ZZye(1:8,:,:))))+sum(sum(sum(ZZoe(1:8,:,:)))));
  
  sepperm = 0;
  for t = 10 : T
    ZZye1x = squeeze(ZZye1(t,:,:))';
    ZZoe1x = squeeze(ZZoe1(t,:,:))';
    for iz = 1 : N
      for iw = 1 : nw
        if ZZye(t-1,iz,iw) > 0
          ZZye1x(widx(t-1,iz,iw),:)  = ZZye1x(widx(t-1,iz,iw),:)  + (1-gamma)*(1-delta)*ZZye(t-1,iz,iw)*P(iz,:);
          ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
          elseif ZZoe(t-1,iz,iw) > 0
          ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
        end
      end
    end
    ZZye1(t,:,:) = ZZye1x';
    ZZoe1(t,:,:) = ZZoe1x';
    if t < T
      sepperm = sepperm + sum(sum(sum(ZZye1(t,:,:).*(split(t,:,:)==1)))) + ...
                sum(sum(sum(ZZoe1(t,:,:).*(splito(t,:,:)==1)))) + chi*(1-delta)*sum(sum(sum(ZZoe(t-1,:,:))));
    end
  end
  for iz = 1 : N
    for iw = 1 : nw
      if ZZye(T,iz,iw) > 0
        ZZye1(T,:,widx(T-1,iz,iw))  = ZZye1(T,:,widx(T-1,iz,iw))  + (1-gamma)*(1-delta)*ZZye(T,iz,iw)*P(iz,:);
        ZZoe1(T,:,woidx(T-1,iz,iw)) = ZZoe1(T,:,woidx(T-1,iz,iw)) + (1-delta)*((1-chi)*ZZoe(T,iz,iw) + gamma*ZZye(T,iz,iw))*P(iz,:);
      elseif ZZoe(T,iz,iw) > 0
        ZZoe1(T,:,woidx(T-1,iz,iw)) = ZZoe1(T,:,woidx(T-1,iz,iw)) + (1-delta)*((1-chi)*ZZoe(T,iz,iw) + gamma*ZZye(T,iz,iw))*P(iz,:);
      end
    end
  end
  sepperm = sepperm + sum(sum(sum(ZZye1(T,:,:).*(split(T,:,:)==1)))) + sum(sum(sum(ZZoe1(T,:,:).*(splito(T,:,:)==1)))) + ...
            chi*(1-delta)*sum(sum(sum(ZZoe(T-1:T,:,:))));
  
  sepperm  = delta + sepperm/sum(sum(sum(ZZye(9:T,:,:)+ZZoe(9:T,:,:))));
  septotal = septemp*sum(sum(sum(ZZye(1:8,:,:))+sum(ZZoe(1:8,:,:)))) + sepperm*sum(sum(sum(ZZye(9:T,:)+ZZoe(9:T,:))));

  clear calibrationit C8 convtmp i io1 it iy1 iy2 ZZoe1 ZZou1 ZZye1 ZZyu1 xx sepy sepo RRe0 RRJ0 philag mu1 pjob1 t ...
        jobfindprob inval0 CV_J0 CV_W0 CVF0 CVW0 tmp wF wF0 woF woW wW wW0 w01 resF0 resW0 annfacy iz iw ZZoe1x ZZye1x        
      
end


%%   PART 2:   Display statistics from the model (e.g. for calibration).

if DO_PART2 == 1
  
  findprob = q*theta;
  
  fprintf('\n       replrate y :   0.5800 - %6.4f             find prob :   0.4000 - %6.4f',b/wavgy,findprob)
  fprintf('\n       replrate o :   0.4540 - %6.4f             unemp old :   0.4000 - %6.4f',bo/wavgo,uo)
  fprintf('\n       destrtemp  :   7.4367 - %6.4f             destrperm :   2.0949 - %6.4f',septemp*100,sepperm*100)
  fprintf('\n       avg wage   :   %6.4f - %6.4f             kappa (%%) :   %6.4f\n',wavg0,wavg,100*kappa)
  
end


%%   PART 3:   Display statistics from the model (e.g. for calibration).

if DO_PART3 == 1

  if uniEPL == 1                                           % Reference file for comparison (unified vs dual EPL)
    
    if     alfa == 0.25,   oo = load('Results\rigid25.mat');
    elseif alfa == 0.50,   oo = load('Results\rigid50.mat');
    elseif alfa == 0.75,   oo = load('Results\rigid75.mat');
    elseif alfa == 0.90,   oo = load('Results\rigid90.mat');
    end
    
    duy       = 100 * (uy - oo.uy)/oo.uy;
    duo       = 100 * (uo - oo.uo)/oo.uo;
    du        = 100 * (u  - oo.u)/oo.u;
    dwavgy    = 100 * (wavgy - oo.wavgy)/oo.wavgy;
    dwavgo    = 100 * (wavgo - oo.wavgo)/oo.wavgo;
    dwavg     = 100 * (wavg  - oo.wavg)/oo.wavg;
    dzavgy    = 100 * (zavgy - oo.zavgy)/oo.zavgy;
    dzavgo    = 100 * (zavgo - oo.zavgo)/oo.zavgo;
    dseptemp  = 100 * (septemp - oo.septemp)/oo.septemp;
    dsepperm  = 100 * (sepperm - oo.sepperm)/oo.sepperm;
    dfindprob = 100 * (findprob - oo.findprob)/oo.findprob;
    dtheta    = 100 * (theta - oo.theta)/oo.theta;
    dkappa    = 100 * (kappa - oo.kappa)/oo.kappa;
  end

  fprintf('\n\n   PARAMETERS:\n\n')
  fprintf('   by    = %6.4f        -        Unemployment benefit (young worker)\n',b)
  fprintf('   bo    = %6.4f        -        Unemployment benefit (older worker)\n',bo)
  fprintf('   k     = %6.4f        -        Vacancy posting cost\n',k)
  fprintf('   A     = %6.4f        -        Matching efficiency\n',A)
  fprintf('   upsil = %6.4f        -        One minus red-tape costs\n',upsil)
  fprintf('   delta = %6.4f        -        Exogenous job destruction rate\n',delta)
  fprintf('   z0    = %6.4f        -        Initial match productivity\n',z(z0idx));
  fprintf('   sigz  = %6.4f        -        Standard deviation for z\n',stdz)
  fprintf('   alpha = %6.4f        -        Weight on old wage\n',alfa)
  if DOWNWARDRIGID == 1
    fprintf('   w1    = max(wNash,%6.4f * w0)      -        Maximum downward adjustment\n',alfadown)
  end
  fprintf('\n\n')

  fprintf('   EPL SCHEME:\n\n')
  if uniEPL == 0
    fprintf('   Benchmark scheme\n\n\n')
  else
    fprintf('   Entry phase (months) :            %2.0f\n',tau_u)
    fprintf('   Slope (in dwys)      :            %2.0f\n\n\n',rho_u)
  end

  fprintf('   STATISTICS:\n\n')
  fprintf('   Unemployment young (%%) :     %7.4f',100*uy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',duy); end
  fprintf('\n   Non-employment old (%%) :     %7.4f',100*uo);      if uniEPL == 1, fprintf('    ( %5.1f %% )',duo); end
  fprintf('\n   Non-employment all (%%) :     %7.4f',100*u);       if uniEPL == 1, fprintf('    ( %5.1f %% )',du); end
  fprintf('\n   Average wage young     :     %7.4f',wavgy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavgy); end
  fprintf('\n   Average wage old       :     %7.4f',wavgo);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavgo); end
  fprintf('\n   Average wage all       :     %7.4f',wavg);         if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavg); end
  fprintf('\n   Average prod young     :     %7.4f',zavgy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dzavgy); end
  fprintf('\n   Average prod old       :     %7.4f',zavgo);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dzavgo); end
  fprintf('\n   JD rate <= 2 years (%%) :     %7.4f',100*septemp);    if uniEPL == 1, fprintf('    ( %5.1f %% )',dseptemp); end
  fprintf('\n   JD rate  > 2 years (%%) :     %7.4f',100*sepperm);    if uniEPL == 1, fprintf('    ( %5.1f %% )',dsepperm); end
  fprintf('\n   Job finding rate (%%)   :     %7.4f',100*findprob);   if uniEPL == 1, fprintf('    ( %5.1f %% )',dfindprob); end
  fprintf('\n   Labor market tightness :     %7.4f',theta);          if uniEPL == 1, fprintf('    ( %5.1f %% )',dtheta); end
  fprintf('\n   Payroll tax (%%)        :     %7.4f',100*kappa);     if uniEPL == 1, fprintf('    ( %5.1f %% )',dkappa); end
  fprintf('\n   Lifetime util newborn  :   %7.4f',U(1))
  if uniEPL == 1
    fprintf('\n   Welfare gain (%%)       :     %7.4f',UU(1))
    fprintf('\n\n   [ Make sure to load the correct reference file for computing %% changes. ]\n')
  end

  fprintf(' \n')
  
end

clear DO_PART1 DO_PART2 DO_PART3