% simulrigid.m

if (exist('ZZye','var') == 0)                              % If ZZye exists, use previous solution as initial guess
  if LOAD_DISTINIT == 1                                    % Starting with decent guess speeds up computations a lot
    if DOWNWARDRIGID == 0,   load distinitrigid.mat
    else                     load distinitdownrigid.mat
    end
  else
    ZZye = zeros(T,N,nw);       ZZyu = zeros(T,1);           
    ZZoe = zeros(T,N,nw);       ZZou = zeros(T,2);
    ZZyu(1,1) = 1;
  end
end

ZZye1 = zeros(T,N,nw);        ZZyu1 = zeros(T,1);        ZZoe1 = zeros(T,N,nw);     ZZou1 = zeros(T,2);
sepo  = zeros(T-1,1);         it    = 0;                 conv  = 1;

while conv > 0.08
 
 ZZye1(1,z0idx,w0idx) = (1-gamma)*q*theta*sum(ZZyu(:,1));

 for t = 2 : T
  ZZye1x = squeeze(ZZye1(t,:,:))';
  ZZoe1x = squeeze(ZZoe1(t,:,:))';
  for iz = 1 : N
   for iw = 1 : nw
    if ZZye(t-1,iz,iw) > 0
     ZZye1x(widx(t-1,iz,iw),:)  = ZZye1x(widx(t-1,iz,iw),:)  + (1-gamma)*(1-delta)*ZZye(t-1,iz,iw)*P(iz,:);
     ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
    elseif ZZoe(t-1,iz,iw) > 0
     ZZoe1x(woidx(t-1,iz,iw),:) = ZZoe1x(woidx(t-1,iz,iw),:) + (1-delta)*((1-chi)*ZZoe(t-1,iz,iw) + gamma*ZZye(t-1,iz,iw))*P(iz,:);
    end
   end
  end
  ZZye1(t,:,:) = ZZye1x';
  ZZoe1(t,:,:) = ZZoe1x';
 end
  
 for iz = 1 : N
  for iw = 1 : nw
   if ZZye(T,iz,iw) > 0
    ZZye1(T,:,widx(T-1,iz,iw))  = ZZye1(T,:,widx(T-1,iz,iw))  + (1-gamma)*(1-delta)*ZZye(T,iz,iw)*P(iz,:);
    ZZoe1(T,:,woidx(T-1,iz,iw)) = ZZoe1(T,:,woidx(T-1,iz,iw)) + (1-delta)*((1-chi)*ZZoe(T,iz,iw) + gamma*ZZye(T,iz,iw))*P(iz,:);
   elseif ZZoe(T,iz,iw) > 0
    ZZoe1(T,:,woidx(T-1,iz,iw)) = ZZoe1(T,:,woidx(T-1,iz,iw)) + (1-delta)*((1-chi)*ZZoe(T,iz,iw) + gamma*ZZye(T,iz,iw))*P(iz,:);
   end
  end
 end

 sepy = sum(sum(ZZye1(2:T,:,:).*( split(2:T,:,:)==1),2),3);
 sepo = sum(sum(ZZoe1(2:T,:,:).*(splito(2:T,:,:)==1),2),3);
  
 ZZye1(2:T,:,:) = (split(2:T,:,:)  < 1).*ZZye1(2:T,:,:);
 ZZoe1(2:T,:,:) = (splito(2:T,:,:) < 1).*ZZoe1(2:T,:,:);
 
 ZZyu1(1,1) = (1-gamma)*(1-q*theta)*ZZyu(1,1) + chi*(sum(sum(sum(ZZoe))) + sum(sum(ZZou)));
  
 ZZyu1(2:T,1) = (1-gamma)*(1-q*theta)*ZZyu(2:end,1) + sepy + (1-gamma)*delta*sum(sum(ZZye(1:T-1,:),2),3);
 ZZyu1(T,1)   = ZZyu1(T,1) + (1-gamma)*delta*sum(sum(ZZye(T,:),2),3);
  
 ZZou1(1,1)   = (1-chi)*ZZou(1,1);
 ZZou1(2:T,1) = (1-chi)*ZZou(2:T,1) + sepo + delta*(1-chi)*sum(sum(ZZoe(1:T-1,:),2),3);
 ZZou1(T,1)   = ZZou1(T,1) + delta*(1-chi)*sum(sum(ZZoe(T,:),2),3);
 ZZou1(1,2)   = (1-chi)*ZZou(1,2)   + gamma*ZZyu(1,1);
 ZZou1(2:T,2) = (1-chi)*ZZou(2:T,2) + gamma*ZZyu(2:T,1) + delta*gamma*sum(sum(ZZye(1:T-1,:),2),3);
 ZZou1(T,2)   = ZZou1(T,2)          + delta*gamma*sum(sum(ZZye(T,:),2),3);
 
 convtmp = max(max(max(abs((ZZye1 - ZZye)./(1 + ZZye))))) + max(max(abs((ZZyu1 - ZZyu)./(1 + ZZyu)))) + ...
           max(max(max(abs((ZZoe1 - ZZoe)./(1 + ZZoe))))) + max(max(abs((ZZou1 - ZZou)./(1 + ZZou))));
 conv    = 10000*convtmp;
 
%   if mod(it,49) == 0,   fprintf(' %7.4f',conv);   end

 ZZye  = ZZye1;            ZZyu  = ZZyu1;           ZZoe  = ZZoe1;              ZZou  = ZZou1;           it = it + 1;
 ZZye1 = zeros(T,N,nw);    ZZyu1 = zeros(T,1);      ZZoe1 = zeros(T,N,nw);      ZZou1 = zeros(T,2);

end

if abs(10000*(sum(sum(sum(ZZye)))+sum(sum(sum(ZZyu)))+sum(sum(sum(ZZoe)))+sum(sum(sum(ZZou)))-1)) > 0.0001
  disp('Distribution not computed correctly!');
end

wavgy = sum(sum(sum(w.*ZZye)))/sum(sum(sum(ZZye)));
wavgo = sum(sum(sum(wo.*ZZoe)))/sum(sum(sum(ZZoe)));
wavg  = sum(sum(sum(w.*ZZye+wo.*ZZoe)))/sum(sum(sum(ZZye+ZZoe)));

Rev = kappa*sum(sum(sum(w.*ZZye))) + kappa*sum(sum(sum(wo.*ZZoe)));
Ben = b*sum(sum(ZZyu)) + bo*sum(sum(ZZou));