% vfirigid.m

if (exist('wgrid','var')) && (ismatrix(W))
  W = repmat(W,1,1,nw);   Wo = repmat(Wo,1,1,nw);   woF = repmat(woF,1,1,nw);   wF = repmat(wF,1,1,nw);
  J = repmat(J,1,1,nw);   Jo = repmat(Jo,1,1,nw);   woW = woF;                  wW = wF;
  w = repmat(w,1,1,nw);   wo = repmat(wo,1,1,nw);
  widx  = 2*ones(T,N,nw);
  woidx = 2*ones(T,N,nw);
end

crito = 10;
crity = 10;

WGRID = zeros(T,N,nw);
for iw = 1 : nw
  WGRID(:,:,iw) = wgrid(iw);
end


%%   (i) Value function iteration for older workers.

C1  = repmat(UoA(aux,:),1,N);    C2  = -repmat(philag,1,N);     C3  = repmat(z',T,1);
C4  = repmat(phi,1,N);           C8  = zeros(T,N);              C1x = repmat(C1,nw,1);
C2x = repmat(C2,nw,1);           C3x = repmat(C3,1,1,nw);       C4x = repmat(C4,1,1,nw);
IDX = zeros(T*N,nw);             ito = 0;                       xx  = 0.60;

critW = 1;
aux1  = T*nw*kron([0 : 1 : N-1]',ones(T,1));

while ((crito > 0.02) || (critW > 0.15)) && (ito < 80)

  Wo_old = Wo;
  C5 = -(1./woW - 1);
  C6 = C3x - woF*(1+kappa);  
  for iw = 1 : nw
    woidxtmp  = reshape(woidx(:,:,iw),T*N,1);
    IDX(:,iw) = aux1 + (woidxtmp-1)*T + repmat([1:T]',N,1);
  end
  
  for i2 = 1 : io1
    CVtmpW = (1/(1+r)) * (1-chi) * ( (1-delta)*max( reshape(permute(Wo(aux,:,:),[1,3,2]),T*nw,N) , C1x )*P' + delta*C1x );
    CVtmpJ = (1/(1+r)) * (1-chi) * ( (1-delta)*max( reshape(permute(Jo(aux,:,:),[1,3,2]),T*nw,N) , C2x )*P' + delta*C2x );
    for iw = 1 : nw
      idx = IDX(:,iw);
      Wo(:,:,iw) = C5(:,:,iw) + reshape(CVtmpW(idx),T,N);
      Jo(:,:,iw) = C6(:,:,iw) + reshape(CVtmpJ(idx),T,N);
    end
  end
  
  CVW  = Wo - C5 - repmat(UoA,1,N,nw);
  CVF  = Jo - C6;
  resW = 1./(1 + CVW);
  resF = (1/(1+kappa))*(C3x + C4x + CVF);
  wo1  = sqrt(resF.*resW*beta/(1-beta));
  wo1(resW > resF) = wo(resW > resF);
  
  wo1new = (1-alfa)*wo1 + alfa*WGRID;                     % Law of motion for wage
  if DOWNWARDRIGID == 1                                   % Downward rigidity
    wo1new = max(wo1new,0.995*WGRID);
  end
  splito = ((resW > resF) + (wo1new < resW) + (wo1new > resF)) > 0;
  crito  = 100*mean(mean(mean(abs(wo1new-wo)./wo)));
%   if mod(ito,10) == 0,   fprintf(' %7.4f',crito);   end
  wo = xx*wo1new + (1-xx)*wo;
  woidx = interp1(wgrid,1:nw,max(min(wo,max(wgrid)),min(wgrid)),'nearest');
  woF = wo;                                      woF(splito==1) = 4.9999;
  woW = wo;                                      woW(splito==1) = 0.001;
  critW = max(max(max(abs(Wo-Wo_old))));
  ito = ito + 1;
  
end


%%   (ii) Value function iteration for young workers.

CV_W = (1/(1+r))*gamma*( (1-delta)*max( reshape(permute(Wo(aux,:,:),[1,3,2]),T*nw,N) , C1x )*P' + delta*C1x );
CV_J = (1/(1+r))*gamma*( (1-delta)*max( reshape(permute(Jo(aux,:,:),[1,3,2]),T*nw,N) , C2x )*P' + delta*C2x );

maxity  = 150;      ity   = 0;       C7 = (1/(1+r))*(1-gamma);
xxtheta = 0.10;     critU = 1;

while ((crity > 0.05) || (critU > 0.005)) && (ity < maxity)
  
  U_old = U;
  
  for i2 = 1 : iy1
    
    q = A * theta^(-psi);
    jobfindprob = q*theta;
    expdur   = (1-gamma+gamma/chi)/(gamma*(1-jobfindprob) + jobfindprob);
    annfacy  = (r/(1+r)) * (1/(1-(1+r)^(-expdur)));
    btildey  = b  + upsil*annfacy*phi;
    btildeoB = bo + upsil*annfacy*phi;
    UoB = -(1./btildeoB-1)/(1-(1/(1+r))*(1-chi));
    RRu = -(1./btildey-1);
    RRe = -(1./wW-1);
    RRJ = C3x - wF*(1+kappa);
    
    [ ~ , w0idx ] = min(abs(squeeze(w(1,z0idx,:))-wgrid'));
    for iw = 1 : nw
      widxtmp  = reshape(widx(:,:,iw),T*N,1);
      IDX(:,iw) = aux1 + (widxtmp-1)*T + repmat([1:T]',N,1);
    end
    
    for i3 = 1 : iy2
      U      = RRu + (1/(1+r)) * ( (1-gamma)*(q*theta*W(1,z0idx,w0idx) + (1-q*theta)*U) + gamma*UoB );
      CVtmpW = C7 * ( (1-delta)*max( reshape(permute(W(aux,:,:),[1,3,2]),T*nw,N) , repmat(U(aux,1),nw,N) )*P' + delta*repmat(U(aux,1),nw,N) ) + CV_W;
      CVtmpJ = C7 * ( (1-delta)*max( reshape(permute(J(aux,:,:),[1,3,2]),T*nw,N) , C2x                   )*P' + delta*C2x                   ) + CV_J;
      for iw = 1 : nw
        idx = IDX(:,iw);
        W(:,:,iw) = RRe(:,:,iw) + reshape(CVtmpW(idx),T,N);
        J(:,:,iw) = RRJ(:,:,iw) + reshape(CVtmpJ(idx),T,N);
      end
    end
    
  end
  
  CVW   = W - RRe - repmat(U,1,N,nw);
  CVF   = J - RRJ;
  resW  = 1./(1 + CVW);
  resF  = (1/(1+kappa))*(C3x + C4x + CVF);
  w1    = sqrt(resF.*resW*beta/(1-beta));
  inval = ((resW > resF) + (1./((1-beta) .* (1 + CVW)) .* (C3x+CVF+C4x)*beta/(1+kappa) < 0)) > 0;
  
  w1(inval) = w(inval);  
  w1new = (1-alfa)*w1 + alfa*WGRID;
  if DOWNWARDRIGID == 1
    w1new = max(w1new,0.995*WGRID);
  end
  split = ((resW > resF) + (w1new < resW) + (w1new > resF) + inval) > 0;  
  crity = 100*mean(mean(mean(abs(w1new-w)./w)));
%   if mod(ity,10) == 0,   fprintf(' %7.4f',crity);   end
  w = xx*w1new + (1-xx)*w;    
  widx = interp1(wgrid,1:nw,max(min(w,max(wgrid)),min(wgrid)),'nearest');  
  wF = w;                                        wF(split==1) = 4.9999;
  wW = w;                                        wW(split==1) = 0.001;
  
  theta1 = ( (1/k)*(1/(1+r)) * A * max(J(1,z0idx,w0idx),0) )^(1/psi);
  if crity < 0.13
    theta  = (1-xxtheta)*theta + xxtheta*theta1;
  end
  
  critU = max(abs(U-U_old));  
  ity = ity + 1;
  
end

if (q > 1),           disp('Careful: Job-filling probability is larger than 1!');   end
if (q*theta > 1),     disp('Careful: Job-finding probability is larger than 1!');   end  
if (ity == maxity),   disp('Hit maxity --> Discard!');                              end

clear C1 C2 C3 C4 C5 C6 C7 CV_J CV_W CVF CVW i1 i2 i3 J1 Jo1 resF resW RRe RRJ RRu TMPq theta1 w1 W1 wo1 Wo1 crito ...
      crity expdur inval ity j V0 U1 maxity philag wW wF woW woF woidxtmp WGRID w1new idx IDX CVtmpJ CVtmpW C1x C2x ...
      C3x C4x aux1 widxtmp wo1new Wo_old