!---------------------------------------------------------------------------------------------------------------------------------------------------
!	module globals: define global variables
!---------------------------------------------------------------------------------------------------------------------------------------------------

module globals
	
	implicit none
	
	save
		
	!	convergence check
	
	double precision :: TOL_theta = 1.0d-2, TOL_budg = 1.0d-3, TOL_avgw = 1.0d-3
	double precision :: TOL_bell = 1.0d-6, TOL_nash = 1.0d-5, TOL_dist = 1.0d-10, TINY = 1.0d-20
	integer :: MAX_budg = 25, MAX_theta = 100, MAX_bell = 1000, MAX_dist = 25000, ERR_cvg
	
	!	model specification
	
	double precision :: delta_sp, young_sp
	
	!	size of state space
	
	integer, parameter :: NT = 120, NZ = 121
	character (len=20) :: fmt = "(121(ES14.7,2X))"
		
	!	model parameters
	
	double precision :: rho, psi, beta, sigma, khi, zeta
	double precision :: gamma, By, Bo, A, k, nu, leis, sig_z, prob_z, P(NZ,NZ), P0(NZ), alpha
	integer :: iz0, model_period

	!	auxiliary variables
	
	logical :: norm_theta
	double precision :: theta, jfind, kappa, delta, annfacO, annfacY(NT), pjob(NT), avg_w, phi(NT), zGrid(NZ)
		
	!	value functions
	
	double precision :: R, Ul(NT), Uo(NT), Wo(NT,NZ), Wy(NT,NZ), Wy0(NT,NZ), Uy(NT), Jo(NT,NZ), Jy(NT,NZ), Jy0(NT,NZ)
	
	!	wage functions
	
	double precision :: wwo(NT,NZ), wwy(NT,NZ), wwy0(NT,NZ), wmin, wmax, upd_wage = 0.25d+0
		
	!	separation decisions
	
	double precision :: acc(NT,NZ)
	integer :: sepy(NT), sepo(NT)
	
	!	equilibrium distributions
	
	double precision :: LE(NT,NZ,2), LU(NT,3)
		
	!	index variables
	
	integer :: it, iz
	
	!	timer

	character (len=8) :: startdate, finishdate
	character (len=10):: starttime, finishtime

end module	