% simulstochz0.m

if (exist('ZZye','var') == 0)                              % If ZZye exists, use previous solution as initial guess!
  ZZye = zeros(T,N);          ZZyu = zeros(T,N);           
  ZZoe = zeros(T,N);          ZZou = zeros(T,N);
  ZZyu(1,1) = 1;                                           % Initialize distribution
end

ZZye1 = zeros(T,N);           ZZyu1 = zeros(T,N);           ZZoe1 = zeros(T,N);           ZZou1 = zeros(T,N);
sepo  = zeros(T-1,1);         it    = 0;                    conv  = 1;

while conv > 0.001

  ZZye1(1,:)     =                  (1-gamma) * q * theta *    alfa  * sum(repmat(ZZyu(:,1),1,N).*(split0 == 0).*repmat(z0distrib,T,1));
  ZZye1(1,z0idx) = ZZye1(1,z0idx) + (1-gamma) * q * theta * (1-alfa) * sum(ZZyu(:,1));
  
  ZZye1(2:T,:)   = (1-gamma)*(1-delta)*ZZye(1:T-1,:)*P;
  ZZye1(T,:)     = ZZye1(T,:) + (1-gamma)*(1-delta)*ZZye(T,:)*P;
  sepy           = sum(ZZye1(2:T,:).*(split(2:T,:)==1),2);
  ZZye1(2:T,:)   = (split(2:T,:) < 1).*ZZye1(2:T,:);
 
  ZZyu1(1,1)     = (1-gamma) * ((1-q*theta)*ZZyu(1,1) + q*theta*alfa*sum(repmat(ZZyu(1,1),1,N).*(split0(1,:) == 1).*z0distrib,2)) + ...
                   chi*(sum(sum(ZZoe)) + sum(sum(ZZou)));
  ZZyu1(2:T,1)   = (1-gamma) * ((1-q*theta)*ZZyu(2:end,1) + q*theta*alfa*sum(repmat(ZZyu(2:end,1),1,N).*(split0(2:end,:) == 1).*...
                   repmat(z0distrib,T-1,1),2)) + sepy + (1-gamma)*delta*sum(ZZye(1:T-1,:),2);
  ZZyu1(T,1)     = ZZyu1(T,1) + (1-gamma)*delta*sum(ZZye(T,:),2);

  ZZoe1(2:T,:)   = (1-delta)*((1-chi)*ZZoe(1:T-1,:) + gamma*ZZye(1:T-1,:))*P;                 % Old and employed
  ZZoe1(T,:)     = ZZoe1(T,:) + (1-delta)*((1-chi)*ZZoe(T,:) + gamma*ZZye(T,:))*P;
  sepo           = sum(ZZoe1(2:T,:).*(splito(2:T,:)==1),2);
  ZZoe1(2:T,:)   = (splito(2:T,:) < 1).*ZZoe1(2:T,:);
  
  ZZou1(1,1)     = (1-chi)*ZZou(1,1);                             % Old and non-employed: Laid off when old
  ZZou1(2:T,1)   = (1-chi)*ZZou(2:T,1) + sepo + delta*(1-chi)*sum(ZZoe(1:T-1,:),2);
  ZZou1(T,1)     = ZZou1(T,1) + delta*(1-chi)*sum(ZZoe(T,:),2);
  ZZou1(1,2)     = (1-chi)*ZZou(1,2)   + gamma*ZZyu(1,1);       % Old and non-employed: Laid off when young
  ZZou1(2:T,2)   = (1-chi)*ZZou(2:T,2) + gamma*ZZyu(2:T,1) + delta*gamma*sum(ZZye(1:T-1,:),2);
  ZZou1(T,2)     = ZZou1(T,2) + delta*gamma*sum(ZZye(T,:),2);
      
  convtmp = abs((ZZye1-ZZye)./(1+ZZye))+abs((ZZyu1-ZZyu)./(1+ZZyu))+abs((ZZoe1-ZZoe)./(1+ZZoe))+abs((ZZou1-ZZou)./(1+ZZou));
  conv    = 100000*max(max(convtmp));
   
  ZZye  = ZZye1;         ZZyu  = ZZyu1;           ZZoe  = ZZoe1;           ZZou  = ZZou1;           it = it + 1;
  ZZye1 = zeros(T,N);    ZZyu1 = zeros(T,N);      ZZoe1 = zeros(T,N);      ZZou1 = zeros(T,N);
     
end

if abs(10000*(sum(sum(ZZye))+sum(sum(ZZyu))+sum(sum(ZZoe))+sum(sum(ZZou))-1)) > 0.0001
  disp('Distribution not computed correctly!');
end

tmp   = (1-gamma) * q * theta * alfa * repmat(ZZyu(:,1),1,N).*(split0 == 0).*repmat(z0distrib,T,1);
wavgy = (sum(sum(w(2:end,:).*ZZye(2:end,:))) + sum(sum(w0.*tmp)) + sum(sum((1-gamma)*q*theta*(1-alfa)*sum(ZZyu(:,1))*w(1,z0idx))))/sum(sum(ZZye));
wavgo = sum(sum(wo.*ZZoe))/sum(sum(ZZoe));
wavg  = (wavgy*sum(sum(ZZye)) + wavgo*sum(sum(ZZoe)))/sum(sum(ZZye+ZZoe));

Rev = kappa*wavgy*sum(sum(ZZye)) + kappa*wavgo*sum(sum(ZZoe));       % Tax revenues
Ben = b*sum(sum(ZZyu)) + bo*sum(sum(ZZou));                          % Spending on benefits