% vfistochz0.m


%%   (i) Value function iteration for older workers.

C1 = repmat(UoA(aux,:),1,N);      C2 = -repmat(philag,1,N);          % Some matrices (can be precomputed)
C3 = repmat(z',T,1);              C4 =  repmat(phi,1,N);             % Some matrices (can be precomputed)
C8 = zeros(T,N);

crito = 1;                                                           % Initialize stopping criterion
while crito > 1e-4
  C5 = -(1./woW - 1);                                                % Some matrix (can be precomputed)
  C6 = C3 - woF*(1+kappa);                                           % Some matrix (can be precomputed)
  for i2 = 1 : io1
    Wo = C5 + (1/(1+r)) * (1-chi) * ( (1-delta)*max( Wo(aux,:) , C1 )*P' + delta*C1 );
    Jo = C6 + (1/(1+r)) * (1-chi) * ( (1-delta)*max( Jo(aux,:) , C2 )*P' + delta*C2 );
  end
  splito = C8;
  CVW  = Wo - C5 - repmat(UoA,1,N);
  CVF  = Jo - C6;
  resW = 1./(1 + CVW);
  resF = (C3 + C4 + CVF)/(1+kappa);  
  wo1 = sqrt(resF.*resW*beta/(1-beta));
  wo1(resW > resF) = wo(resW > resF);
  splito(resW > resF) = 1;
  crito = 100*max(max(abs(wo1-wo)./wo));         wo = xx*wo1 + (1-xx)*wo;
  woF = wo;                                      woF(splito==1) = 4.9999;
  woW = wo;                                      woW(splito==1) = 0.001;
end


%%   (ii) Value function iteration for young workers.

% Continuation values for young workers experiencing the gamma-shock. These can be precomputed.
CV_W = (1/(1+r))*gamma*( (1-delta)*max( Wo(aux,:) , repmat(UoA(aux,1),1,N) )*P' + delta*repmat(UoA(aux,1),1,N) );
CV_J = (1/(1+r))*gamma*( (1-delta)*max( Jo(aux,:) , C2                     )*P' + delta*C2 );

% Continuation values for young workers experiencing the gamma-shock (initial matches). These can be precomputed.
CV_W0 = (1/(1+r))*gamma*( (1-delta)*max( repmat(Wo(2,:),T,1) , repmat(UoA(2,1),T,N) )*P' + delta*repmat(UoA(2,1),T,N) );
CV_J0 = (1/(1+r))*gamma*( (1-delta)*max( repmat(Jo(2,:),T,1) , repmat(C2(2,:),T,1)  )*P' + delta*repmat(C2(2,:),T,1) );

if exist('pjob','var') == 0                                % pjob = Probability of accepting a job offer (guess)
  pjob = ones(T,1);                                        % Initial guess (if no previous guess is available)
end

maxity = 600;                                              % Maximum number of iterations (show warning if hit)
ity    = 0;                                                % Initialize iteration counter
C7     = (1/(1+r))*(1-gamma);                              % Some number (can be precomputed)
crity  = 100;                                              % Initialize

C20 = repmat(C2(2,:),T,1);

while (crity > 2) && (ity < maxity)                        % Outer loop over equilibrium wage function
  
  for i2 = 1 : iy1                                         % I iterate over theta a prespecified number of times
    
    pjob1 = (split0 == 0) * z0distrib';                    % Implied job acceptance probability by tenure
    pjob  = xx_pjob * pjob1 + (1-xx_pjob) * pjob;          % Updated guess for pjob

    q = A * theta^(-psi);
    jobfindprob = alfa*q*theta*pjob + (1-alfa)*q*theta;
    expdur   = (1-gamma+gamma/chi)./(gamma*(1-jobfindprob) + jobfindprob);
    annfacy  = (r/(1+r)) .* (1./(1-(1+r).^(-expdur)));     % Annuity factor: Young workers
    btildey  = b  + upsil*annfacy.*phi;                    % Non-employment income for young workers
    btildeoB = bo + upsil*annfacy.*phi;                    % Non-employment income for older workers
    UoB = -(1./btildeoB-1)/(1-(1/(1+r))*(1-chi));          % Non-employed older workers: laid off when young
    RRu = -(1./btildey-1);                                 % Some matrix (can be precomputed)
    RRe = -(1./wW-1);                                      % Single-period return matrix (can be precomputed)
    RRJ = C3 - wF*(1+kappa);                               % Single-period return matrix (can be precomputed)
    
    RRe0 = -(1./wW0-1);                                    % Single-period return matrix (can be precomputed)
    RRJ0 = C3 - wF0*(1+kappa);                             % Single-period return matrix (can be precomputed)
    
    for i3 = 1 : iy2                                       % Iterate over value functions (given wage)      
      U  = RRu  + (1/(1+r)) * ( (1-gamma)*(alfa*q*theta*max(W0,repmat(U,1,N))*z0distrib' + (1-alfa)*q*theta*W(1,z0idx) + (1-q*theta)*U) + gamma*UoB );
      W  = RRe  + C7*( (1-delta)*max(W(aux,:),repmat(U(aux,1),1,N))*P' + delta*repmat(U(aux,1),1,N) ) + CV_W;
      J  = RRJ  + C7*( (1-delta)*max(J(aux,:),C2                  )*P' + delta*C2) + CV_J;
      W0 = RRe0 + C7*( (1-delta)*max(repmat(W(2,:),T,1),U(2,1))*P'     + delta*U(2,1)) + CV_W0;
      J0 = RRJ0 + C7*( (1-delta)*max(repmat(J(2,:),T,1),C20)*P'        + delta*C20   ) + CV_J0;
    end
    
    theta1 = ( (1/k)*(1/(1+r)) * A * (alfa * mu * (max(J0,0)*z0distrib') + (1-alfa) * max(J(1,z0idx),0) ) )^(1/psi);
    theta  = (1-xx)*theta + xx*theta1;
     
  end
  
  split0 = C8;                                             % Solve wage bargaining problem (initial matches)
  CVW0   = W0 - RRe0 - repmat(U,1,N);
  CVF0   = J0 - RRJ0;
  resW0 = 1./(1 + CVW0);
  resF0 = (C3 + CVF0)/(1+kappa);                           % C4 drops out here (phi = 0)
  w01   = sqrt(resF0.*resW0*beta/(1-beta));
  inval0 = ((resW0 > resF0) + (1./((1-beta) .* (1 + CVW0)) .* (C3 + CVF0)*beta/(1+kappa) < 0)) > 0;
  w01(inval0) = w0(inval0);                        split0(inval0) = 1;
  critw0 = 100*max(max(abs(w01-w0)./w0));          w0  = xx0*w01 + (1-xx0)*w0;
  wF0 = w0;                                        wF0(split0==1) = 4.9999;
  wW0 = w0;                                        wW0(split0==1) = 0.001;
  
  split = C8;                                              % Solve wage bargaining problem
  CVW   = W - RRe - repmat(U,1,N);
  CVF   = J - RRJ;
  resW = 1./(1 + CVW);
  resF = (C3 + C4 + CVF)/(1+kappa);  
  w1   = sqrt(resF.*resW*beta/(1-beta));
  w1(resW > resF) = w(resW > resF);              split(resW > resF) = 1;
  
  crity = 100*max(max(abs(w1-w)./w));            w = xx*w1 + (1-xx)*w;
  wF = w;                                        wF(split==1) = 4.9999;
  wW = w;                                        wW(split==1) = 0.001;
  ity = ity + 1;
  
  crity = max(crity,critw0);
    
end

if (q > 1),           disp('Careful: Job-filling probability is larger than 1!');   end
if (q*theta > 1),     disp('Careful: Job-finding probability is larger than 1!');   end
if (ity == maxity),   disp('Hit maxity.');                              end

clear C1 C2 C3 C4 C5 C6 C7 CV_J CV_W CVF CVW i1 i2 i3 J1 Jo1 resF resW RRe RRJ RRu TMPq theta1 w1 W1 wo1 Wo1 crito ...
      crity expdur inval ity j V0 U1 maxity