!---------------------------------------------------------------------------------------------------------------------------------------------------
!	module globals: define global variables
!---------------------------------------------------------------------------------------------------------------------------------------------------

module globals
	
	implicit none
	
	save
		
	!	convergence check
	
	double precision :: TOL_theta = 1.0d-2, TOL_budg = 1.0d-4, TOL_avgw = 1.0d-4
	double precision :: TOL_bell = 1.0d-6, TOL_nash = 1.0d-5, TOL_dist = 1.0d-10, TINY = 1.0d-20
	integer :: MAX_budg = 100, MAX_theta = 100, MAX_bell = 4000, MAX_dist = 25000, ERR_cvg
	
	!	model specification
	
	double precision :: delta_sp, young_sp
	
	!	size of state space
	
	integer, parameter :: NT = 120, NZ = 101
	character (len=20) :: fmt = "(101(ES14.7,2X))"
	
	!	model parameters
	
	double precision :: rho, psi, beta, sigma, khi, zeta
	double precision :: gamma, By, Bo, A, k, nu, leis, sig_z, prob_z, P(NZ,NZ)
	integer :: iz0, model_period

	!	auxiliary variables
	
	logical :: norm_theta
	double precision :: theta, jfind, kappa, delta, annfacO, annfacY, avg_w, phi(NT), zGrid(NZ), alpha0, alpha1, H
		
	!	value functions
	
	double precision :: R, Ul(NT), Uo(NT), Uy(NT)
	double precision :: Wo_0(NT,NZ), Wy_0(NT,NZ), Wo_1(NT,NZ), Wy_1(NT,NZ), Jo_0(NT,NZ), Jo_1(NT,NZ), Jy_0(NT,NZ), Jy_1(NT,NZ)
	
	!	wage functions
	
	double precision :: wwo_0(NT,NZ), wwy_0(NT,NZ), wwo_1(NT,NZ), wwy_1(NT,NZ), wmin, wmax, upd_wage = 0.25d+0
	
	!	effort decisions
	
	double precision ::	eff_y(NT,NZ), eff_o(NT,NZ), pi_y(NT,NZ), pi_o(NT,NZ)
	
	!	separation decisions
	
	integer :: sepy_0(NT), sepo_0(NT), sepy_1(NT), sepo_1(NT)
	
	!	equilibrium distributions
	
	double precision :: LE_0(NT,NZ,2), LE_1(NT,NZ,2), LU(NT,3)
		
	!	index variables
	
	integer :: it, iz
	
	!	timer

	character (len=8) :: startdate, finishdate
	character (len=10):: starttime, finishtime

end module	