!---------------------------------------------------------------------------------------------------------------------------------------------------
!	main program
!---------------------------------------------------------------------------------------------------------------------------------------------------

program main

	use globals
	use misc_functions
	use solve_model
	
	implicit none	
	
	!	set the starting time

	call date_and_time(startdate,starttime)

	!	initialize parameters
	
	call initial_parameters()
	
	!	set initial values	
	
	call set_initial_guesses()
	
	!	normalize theta
	
	norm_theta = .true.

	!	compute model equilibrium
	
	call compute_model_equilibrium()
	
	!	display results
	
	call display_statistics()
	
	!	set the finishing time

	call date_and_time(finishdate,finishtime)


	!	print the starting and finishing times

	write(*, '(/)') 
	write(*, '(12A)') 'The program started at  ', startdate(7:8),'/',startdate(5:6),'/',startdate(1:4),' ', &
												  starttime(1:2),'h',starttime(3:4),'m',starttime(5:6)
	write(*, '(12A)') 'The program finished at ', finishdate(7:8),'/',finishdate(5:6),'/',finishdate(1:4),' ', &
												  finishtime(1:2),'h',finishtime(3:4),'m',finishtime(5:6)
		
	
end program main