% Model with human capital accumulation.

clearvars
tic

nz = 101;     stdz = 0.044;     kappa = 9.5000;     uniEPL = 0;

% z0idx = 35;   b = 0.2987;   bo = 0.2320;   k = 0.2445;   wavg0 = 0.5142;     % pi1 = 0.037 / pi2 = 0.25
z0idx = 36;   b = 0.2946;   bo = 0.2297;   k = 0.2362;   wavg0 = 0.5075;     % pi1 = 0.050 / pi2 = 0.50
% z0idx = 37;   b = 0.2902;   bo = 0.2271;   k = 0.2261;   wavg0 = 0.5003;     % pi1 = 0.072 / pi2 = 0.75

Hprem = 0.5;                                               % HC wage premium
pi1   = 0.05;                                              % Parameter in HC upgrading function (Level)
pi2   = 0.50;                                              % Parameter in HC upgrading function (Curvature)

init;                                                      % Initialization
vfihumcap;                                                 % Value function iteration
simulhumcap;                                               % Compute stationary distribution

for calibrationit = 1 : 3                                  % Uncomment to calibrate b and bo
  critgov = 1;                                             % Initialize
  while abs(critgov) > 1e-5                                % Balance the government budget
    initx;   vfihumcap;   simulhumcap;                     % Solve the model
    critgov = (Rev-Ben)/Rev;                               % Excess revenues
    kappa   = kappa - 0.10 * critgov;                      % Adjust payroll tax rate
    wavg0   = 0.5*wavg + 0.5*wavg0;                        % Adjust guess for average wage
  end
  b  = b  - 0.28 * (b/wavgy  - 0.58);                      % Calibration: Set new value for b
  bo = bo - 0.28 * (bo/wavgo - 0.4540);   fprintf('x ')    % Calibration: Set new value for bo
end

showstatshumcap;
toc