% showstatsHC.m

DO_PART1 = 1;                          % Compute job destruction rates
DO_PART2 = 1;                          % Display statistics from the model (e.g. for calibration)
DO_PART3 = 1;                          % Display parameters and statistics from the model (e.g. to create a txt-file)


%%   PART 1:   Compute job destruction rates.

if DO_PART1 == 1
  
  qo = sum(sum(ZZoe+ZZoeH))+sum(sum(ZZou));   uo = sum(sum(ZZou))/qo;  % Population share and unemployment rate (o)
  qy = 1-qo;                            uy   = sum(sum(ZZyu))/qy;      % Population share and unemployment rate (y)
  u  = qy*uy+qo*uo;                     outp = sum(ZZye+ZZoe)*z + sum(ZZyeH+ZZoeH)*z*(1+Hprem);

  zavgy = (sum(ZZye)*z + sum(ZZyeH)*z*(1+Hprem))/sum(sum(ZZye+ZZyeH)); % Average productivity (young)
  zavgo = (sum(ZZoe)*z + sum(ZZoeH)*z*(1+Hprem))/sum(sum(ZZoe+ZZoeH)); % Average productivity (old)
  zavg  = (sum(ZZye)*z + sum(ZZyeH)*z*(1+Hprem) + sum(ZZoe)*z + sum(ZZoeH)*z*(1+Hprem))/sum(sum(ZZye+ZZyeH+ZZoe+ZZoeH));

  septemp = 0;                                                         % Compute separation rate for temporary jobs   
  for i = 2 : 9
    ZZye1(i,:)  = (1-gamma)*(1-delta)*(1-piy(i-1,:)).*ZZye(i-1,:)*P;
    septemp     = septemp + sum(ZZye1(i,split(i,:)==1));
    ZZye1H(i,:) = (1-gamma)*(1-delta)*piy(i-1,:).*ZZye(i-1,:)*P + (1-gamma)*(1-delta)*ZZyeH(i-1,:)*P;
    septemp     = septemp + sum(ZZye1H(i,splitH(i,:)==1));
    ZZoe1(i,:)  = (1-chi)*(1-delta)*(1-pio(i-1,:)).*ZZoe(i-1,:)*P + gamma*(1-delta)*(1-piy(i-1,:)).*ZZye(i-1,:)*P;
    septemp     = septemp + sum(ZZoe1(i,splito(i,:)==1)) + chi*sum(ZZoe(i-1,:));
    ZZoe1H(i,:) = (1-chi)*(1-delta)*pio(i-1,:).*ZZoe(i-1,:)*P + gamma*(1-delta)*piy(i-1,:).*ZZye(i-1,:)*P + ...
                  (1-chi)*(1-delta)*ZZoeH(i-1,:)*P + gamma*(1-delta)*ZZyeH(i-1,:)*P;
    septemp     = septemp + sum(ZZoe1H(i,splitoH(i,:)==1)) + chi*sum(ZZoeH(i-1,:));
  end
  septemp = delta + septemp/(sum(sum(ZZye(1:8,:)))+sum(sum(ZZoe(1:8,:)))+sum(sum(ZZyeH(1:8,:)))+sum(sum(ZZoeH(1:8,:))));

  sepperm = 0;                                                         % Compute separation rate for permanent jobs
  for i = 10 : T-1
    ZZye1(i,:)  = (1-gamma)*(1-delta)*(1-piy(i-1,:)).*ZZye(i-1,:)*P;
    sepperm     = sepperm + sum(ZZye1(i,split(i,:)==1));
    ZZye1H(i,:) = (1-gamma)*(1-delta)*piy(i-1,:).*ZZye(i-1,:)*P + (1-gamma)*(1-delta)*ZZyeH(i-1,:)*P;
    sepperm     = sepperm + sum(ZZye1H(i,splitH(i,:)==1));
    ZZoe1(i,:)  = (1-chi)*(1-delta)*(1-pio(i-1,:)).*ZZoe(i-1,:)*P + gamma*(1-delta)*(1-piy(i-1,:)).*ZZye(i-1,:)*P;
    sepperm     = sepperm + sum(ZZoe1(i,splito(i,:)==1)) + chi*sum(ZZoe(i-1,:));
    ZZoe1H(i,:) = (1-chi)*(1-delta)*pio(i-1,:).*ZZoe(i-1,:)*P + gamma*(1-delta)*piy(i-1,:).*ZZye(i-1,:)*P + ...
                  (1-chi)*(1-delta)*ZZoeH(i-1,:)*P + gamma*(1-delta)*ZZyeH(i-1,:)*P;
    sepperm     = sepperm + sum(ZZoe1H(i,splitoH(i,:)==1)) + chi*sum(ZZoeH(i-1,:));
  end

  ZZoe1(T,:)  = sum((1-chi)*(1-delta)*(1-pio(T-1:T,:)).*ZZoe(T-1:T,:)*P) + sum(gamma*(1-delta)*(1-piy(T-1:T,:)).*ZZye(T-1:T,:)*P);
  ZZoe1H(T,:) = sum((1-chi)*(1-delta)*pio(T-1:T,:).*ZZoe(T-1:T,:)*P) + sum(gamma*(1-delta)*piy(T-1:T,:).*ZZye(T-1:T,:)*P) + ...
                sum((1-chi)*(1-delta)*ZZoeH(T-1:T,:)*P) + sum(gamma*(1-delta)*ZZyeH(T-1:T,:)*P);

  sepperm  = sepperm + sum(ZZoe1(T,splito(T,:)==1)) + chi*(1-delta)*sum(ZZoe(T,:)) + ...
             sum(ZZoe1H(T,splitoH(T,:)==1)) + chi*(1-delta)*sum(ZZoeH(T,:));
  sepperm  = delta + sepperm/sum(sum(ZZye(9:T,:)+ZZoe(9:T,:)+ZZyeH(9:T,:)+ZZoeH(9:T,:)));
  
  shareHChigh = sum(sum(ZZyeH+ZZoeH))/(sum(sum(ZZye+ZZoe+ZZyeH+ZZoeH)));
  
  pieavg = sum(sum(piy.*ZZye + pio.*ZZoe))/sum(sum(ZZye+ZZoe));
  
  eavg     = (sum(sum(ey.*ZZye)) + sum(sum(eo.*ZZoe)))/sum(sum(ZZye + ZZoe));
  etempavg = (sum(sum(ey(1:8,:).*ZZye(1:8,:))) + sum(sum(eo(1:8,:).*ZZoe(1:8,:))))/sum(sum(ZZye(1:8,:)+ZZoe(1:8,:)));
  epermavg = (sum(sum(ey(9:end,:).*ZZye(9:end,:))) + sum(sum(eo(9:end,:).*ZZoe(9:end,:))))/sum(sum(ZZye(9:end,:)+ZZoe(9:end,:)));
  enewhire = ey(1,z0idx);

  clear aux calibrationit C8 convtmp i io1 it iy1 iy2 ZZoe1 ZZou1 ZZye1 ZZyu1 xx sepy sepo annfaco C5H C6H CV_JH ...
        CV_WH CVFH CVWH invalH resFH resWH RReH RRJH sepoH sepyH w1H wFH wo1H woFH woWH wWH ZZoe1H ZZye1H
      
end


%%   PART 2:   Display statistics from the model (e.g. for calibration).

if DO_PART2 == 1
  
  findprob = q*theta;
  
  fprintf('\n       replrate y :   0.5800 - %6.4f             find prob :   0.4000 - %6.4f',b/wavgy,findprob)
  fprintf('\n       replrate o :   0.4540 - %6.4f             unemp old :   0.4000 - %6.4f',bo/wavgo,uo)
  fprintf('\n       destrtemp  :   7.4367 - %6.4f             destrperm :   2.0949 - %6.4f',septemp*100,sepperm*100)
  fprintf('\n       avg wage   :   %6.4f - %6.4f              kappa (%%) :   %6.4f',wavg0,wavg,100*kappa)
  fprintf('\n       avg pi(e)  :   %6.4f                      share HC  :   %6.4f\n',pieavg,shareHChigh)
%   fprintf('       theta      :   1.0000 - %6.4f\n',theta)

end


%%   PART 3:   Display statistics from the model (e.g. for calibration).

if DO_PART3 == 1

  if uniEPL == 1                                           % Reference file for comparison (unified vs dual EPL)
    
    if     pi2 == 0.25,   oo = load('Results\HC25.mat');
    elseif pi2 == 0.50,   oo = load('Results\HC50.mat');
    elseif pi2 == 0.75,   oo = load('Results\HC75.mat');
    end
    
    dshareHC  = 100 * (shareHChigh - oo.shareHChigh)/oo.shareHChigh;
    deavg     = 100 * (eavg  - oo.eavg)/oo.eavg;
    denewhire = 100 * (enewhire  - oo.enewhire)/oo.enewhire;
    detempavg = 100 * (etempavg  - oo.etempavg)/oo.etempavg;
    depermavg = 100 * (epermavg  - oo.epermavg)/oo.epermavg;
    
    duy       = 100 * (uy - oo.uy)/oo.uy;
    duo       = 100 * (uo - oo.uo)/oo.uo;
    du        = 100 * (u  - oo.u)/oo.u;
    dwavgy    = 100 * (wavgy - oo.wavgy)/oo.wavgy;
    dwavgo    = 100 * (wavgo - oo.wavgo)/oo.wavgo;
    dwavg     = 100 * (wavg  - oo.wavg)/oo.wavg;
    dzavgy    = 100 * (zavgy - oo.zavgy)/oo.zavgy;
    dzavgo    = 100 * (zavgo - oo.zavgo)/oo.zavgo;
    dseptemp  = 100 * (septemp - oo.septemp)/oo.septemp;
    dsepperm  = 100 * (sepperm - oo.sepperm)/oo.sepperm;
    dfindprob = 100 * (findprob - oo.findprob)/oo.findprob;
    dtheta    = 100 * (theta - oo.theta)/oo.theta;
    dkappa    = 100 * (kappa - oo.kappa)/oo.kappa;
  end

  fprintf('\n\n   PARAMETERS:\n\n')
  fprintf('   by    = %6.4f        -        Unemployment benefit (young worker)\n',b)
  fprintf('   bo    = %6.4f        -        Unemployment benefit (older worker)\n',bo)
  fprintf('   k     = %6.4f        -        Vacancy posting cost\n',k)
  fprintf('   A     = %6.4f        -        Matching efficiency\n',A)
  fprintf('   upsil = %6.4f        -        One minus red-tape costs\n',upsil)
  fprintf('   delta = %6.4f        -        Exogenous job destruction rate\n',delta)
  fprintf('   z0    = %6.4f        -        Initial match productivity\n',z(z0idx));
  fprintf('   sigz  = %6.4f        -        Standard deviation for z\n',stdz)
  fprintf('   H     = %6.4f        -        Wage premium (human capital)\n',Hprem)
  fprintf('   pi1   = %6.4f        -        Level parameter\n',pi1);
  fprintf('   pi2   = %6.4f        -        Elasticity parameter\n',pi2);
%   fprintf('   alpha = %6.4f        -        Probability of upgrading HC\n',alfa);
  fprintf('\n\n')

  fprintf('   EPL SCHEME:\n\n')
  if uniEPL == 0
    fprintf('   Benchmark scheme\n\n\n')
  else
    fprintf('   Entry phase (months) :            %2.0f\n',tau_u)
    fprintf('   Slope (in dwys)      :            %2.0f\n\n\n',rho_u)
  end

  fprintf('   STATISTICS:\n')
  fprintf('\n   %% high-HC workers (%%)  :     %7.4f',100*shareHChigh);   if uniEPL == 1, fprintf('    ( %5.1f %% )',dshareHC); end
  fprintf('\n   HC effort all (%%)      :     %7.4f',100*eavg);           if uniEPL == 1, fprintf('    ( %5.1f %% )',deavg); end
  fprintf('\n   HC effort new hire (%%) :     %7.4f',100*enewhire);       if uniEPL == 1, fprintf('    ( %5.1f %% )',denewhire); end
  fprintf('\n   HC effort temp (%%)     :     %7.4f',100*etempavg);       if uniEPL == 1, fprintf('    ( %5.1f %% )',detempavg); end
  fprintf('\n   HC effort perm (%%)     :     %7.4f',100*epermavg);     if uniEPL == 1, fprintf('    ( %5.1f %% )',depermavg); end
  
  fprintf('\n\n   Unemployment young (%%) :     %7.4f',100*uy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',duy); end
  fprintf('\n   Non-employment old (%%) :     %7.4f',100*uo);      if uniEPL == 1, fprintf('    ( %5.1f %% )',duo); end
  fprintf('\n   Non-employment all (%%) :     %7.4f',100*u);       if uniEPL == 1, fprintf('    ( %5.1f %% )',du); end
  fprintf('\n   Average wage young     :     %7.4f',wavgy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavgy); end
  fprintf('\n   Average wage old       :     %7.4f',wavgo);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavgo); end
  fprintf('\n   Average wage all       :     %7.4f',wavg);         if uniEPL == 1, fprintf('    ( %5.1f %% )',dwavg); end
  fprintf('\n   Average prod young     :     %7.4f',zavgy);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dzavgy); end
  fprintf('\n   Average prod old       :     %7.4f',zavgo);        if uniEPL == 1, fprintf('    ( %5.1f %% )',dzavgo); end
  fprintf('\n   JD rate <= 2 years (%%) :     %7.4f',100*septemp);    if uniEPL == 1, fprintf('    ( %5.1f %% )',dseptemp); end
  fprintf('\n   JD rate  > 2 years (%%) :     %7.4f',100*sepperm);    if uniEPL == 1, fprintf('    ( %5.1f %% )',dsepperm); end
  fprintf('\n   Job finding rate (%%)   :     %7.4f',100*findprob);   if uniEPL == 1, fprintf('    ( %5.1f %% )',dfindprob); end
  fprintf('\n   Labor market tightness :     %7.4f',theta);          if uniEPL == 1, fprintf('    ( %5.1f %% )',dtheta); end
  fprintf('\n   Payroll tax (%%)        :     %7.4f',100*kappa);     if uniEPL == 1, fprintf('    ( %5.1f %% )',dkappa); end
  fprintf('\n   Lifetime util newborn  :   %7.4f',U(1))
  if uniEPL == 1
    fprintf('\n   Welfare gain (%%)       :     %7.4f',UU(1))
    fprintf('\n\n   [ Make sure to load the correct reference file for computing %% changes. ]\n')
  end

  fprintf(' \n')
  
end