% simulHC.m

if (exist('ZZye','var') == 0)                              % If ZZye exists, use previous solution as initial guess!
  ZZye = zeros(T,N);          ZZyu = zeros(T,N);           ZZyeH = zeros(T,N);
  ZZoe = zeros(T,N);          ZZou = zeros(T,N);           ZZoeH = zeros(T,N);
  ZZyu(1,1) = 1;                                           % Initialize distribution
end

ZZye1  = zeros(T,N);          ZZyu1  = zeros(T,N);          ZZoe1 = zeros(T,N);           ZZou1 = zeros(T,N);
ZZye1H = zeros(T,N);          ZZoe1H = zeros(T,N);          sepo  = zeros(T-1,1);         it    = 0;       conv  = 1;

while conv > 0.001

  ZZye1(1,z0idx) = (1-gamma)*q*theta*sum(ZZyu(:,1));
  ZZye1(2:T,:)   = (1-gamma)*(1-delta)*(1-piy(1:T-1,:)).*ZZye(1:T-1,:)*P;
  ZZye1H(2:T,:)  = (1-gamma)*(1-delta)*piy(1:T-1,:).*ZZye(1:T-1,:)*P + (1-gamma)*(1-delta)*ZZyeH(1:T-1,:)*P;
  ZZye1(T,:)     = ZZye1(T,:) + (1-gamma)*(1-delta)*(1-piy(T,:)).*ZZye(T,:)*P;
  ZZye1H(T,:)    = ZZye1H(T,:) + (1-gamma)*(1-delta)*piy(T,:).*ZZye(T,:)*P + (1-gamma)*(1-delta)*ZZyeH(T,:)*P;
  sepy           = sum(ZZye1(2:T,:) .*(split(2:T,:)==1) ,2);
  sepyH          = sum(ZZye1H(2:T,:).*(splitH(2:T,:)==1),2);
  ZZye1(2:T,:)   = (split(2:T,:)  < 1).*ZZye1(2:T,:);
  ZZye1H(2:T,:)  = (splitH(2:T,:) < 1).*ZZye1H(2:T,:);
 
  ZZyu1(1,1)     = (1-gamma)*(1-q*theta)*ZZyu(1,1) + chi*(sum(sum(ZZoe)) + sum(sum(ZZou)) + sum(sum(ZZoeH)));
  
  ZZyu1(2:T,1)   = (1-gamma)*(1-q*theta)*ZZyu(2:end,1) + sepy + sepyH + (1-gamma)*delta*sum(ZZye(1:T-1,:),2) + ...
                   (1-gamma)*delta*sum(ZZyeH(1:T-1,:),2);
  ZZyu1(T,1)     = ZZyu1(T,1) + (1-gamma)*delta*sum(ZZye(T,:),2) + (1-gamma)*delta*sum(ZZyeH(T,:),2);

  ZZoe1(2:T,:)   = (1-delta)*((1-chi)*(1-pio(1:T-1,:)).*ZZoe(1:T-1,:) + gamma*(1-piy(1:T-1,:)).*ZZye(1:T-1,:))*P;
  ZZoe1H(2:T,:)  = (1-delta)*((1-chi)*ZZoeH(1:T-1,:) + gamma*ZZyeH(1:T-1,:))*P + ...
                   (1-delta)*((1-chi)*pio(1:T-1,:).*ZZoe(1:T-1,:) + gamma*piy(1:T-1,:).*ZZye(1:T-1,:))*P;
  ZZoe1(T,:)     = ZZoe1(T,:)  + (1-delta)*((1-chi)*(1-pio(T,:)).*ZZoe(T,:) + gamma*(1-piy(T,:)).*ZZye(T,:))*P;
  ZZoe1H(T,:)    = ZZoe1H(T,:) + (1-delta)*((1-chi)*pio(T,:).*ZZoe(T,:) + gamma*piy(T,:).*ZZye(T,:))*P + ...
                   (1-delta)*((1-chi)*ZZoeH(T,:) + gamma*ZZyeH(T,:))*P;
  sepo           = sum(ZZoe1(2:T,:) .*(splito(2:T,:)==1) ,2);
  sepoH          = sum(ZZoe1H(2:T,:).*(splitoH(2:T,:)==1),2);
  ZZoe1(2:T,:)   = (splito(2:T,:)  < 1).*ZZoe1(2:T,:);
  ZZoe1H(2:T,:)  = (splitoH(2:T,:) < 1).*ZZoe1H(2:T,:);
  
  ZZou1(1,1)     = (1-chi)*ZZou(1,1);
  ZZou1(2:T,1)   = (1-chi)*ZZou(2:T,1) + sepo + sepoH + delta*(1-chi)*sum(ZZoe(1:T-1,:),2) + ...
                   delta*(1-chi)*sum(ZZoeH(1:T-1,:),2);
  ZZou1(T,1)     = ZZou1(T,1) + delta*(1-chi)*sum(ZZoe(T,:),2) + delta*(1-chi)*sum(ZZoeH(T,:),2);
  ZZou1(1,2)     = (1-chi)*ZZou(1,2)   + gamma*ZZyu(1,1);
  ZZou1(2:T,2)   = (1-chi)*ZZou(2:T,2) + gamma*ZZyu(2:T,1) + delta*gamma*sum(ZZye(1:T-1,:),2) + ...
                   delta*gamma*sum(ZZyeH(1:T-1,:),2);
  ZZou1(T,2)     = ZZou1(T,2) + delta*gamma*sum(ZZye(T,:),2) + delta*gamma*sum(ZZyeH(T,:),2);

  convtmp = abs((ZZye1-ZZye)./(1+ZZye))+abs((ZZyu1-ZZyu)./(1+ZZyu))+abs((ZZoe1-ZZoe)./(1+ZZoe))+...
            abs((ZZou1-ZZou)./(1+ZZou))+abs(ZZye1H-ZZyeH)./(1+ZZyeH)+abs(ZZoe1H-ZZoeH)./(1+ZZoeH);
  conv    = 100000*max(max(convtmp));
   
  ZZye   = ZZye1;        ZZyu   = ZZyu1;          ZZoe  = ZZoe1;           ZZou  = ZZou1;
  ZZyeH  = ZZye1H;       ZZoeH  = ZZoe1H;         it = it + 1;
  ZZye1  = zeros(T,N);   ZZyu1  = zeros(T,N);     ZZoe1 = zeros(T,N);      ZZou1 = zeros(T,N);
  ZZye1H = zeros(T,N);   ZZoe1H = zeros(T,N);
   
end

if abs(10000*(sum(sum(ZZye))+sum(sum(ZZyu))+sum(sum(ZZoe))+sum(sum(ZZou))+sum(sum(ZZyeH))+sum(sum(ZZoeH))-1)) > 0.0001
  disp('Distribution not computed correctly!');
end

wavgy = sum(sum(w.*ZZye+wH.*ZZyeH))/sum(sum(ZZye+ZZyeH));           % Average wage (young)
wavgo = sum(sum(wo.*ZZoe+woH.*ZZoeH))/sum(sum(ZZoe+ZZoeH));         % Average wage (old)
wavg  = sum(sum(w.*ZZye+wH.*ZZyeH+wo.*ZZoe+woH.*ZZoeH))/sum(sum(ZZye+ZZyeH+ZZoe+ZZoeH));  % Average wage (all)

Rev = kappa*sum(sum(w.*ZZye+wH.*ZZyeH+wo.*ZZoe+woH.*ZZoeH));        % Tax revenues
Ben = b*sum(sum(ZZyu)) + bo*sum(sum(ZZou));                         % Spending on benefits